using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using Microsoft.AspNetCore.Authorization;
using Api.SignToken;
using Microsoft.IdentityModel.Tokens;
using System.Text;
using System.Security.Claims;
using Microsoft.AspNetCore.Authentication.JwtBearer;
using System.IdentityModel.Tokens.Jwt;
using Pivotal.Discovery.Client;
using NLog.Extensions.Logging;
using NLog.Web;
using Microsoft.AspNetCore.Mvc.Versioning;
using MadRunFabric.Common.Options;
using AutoMapper;
using Hangfire;
using StackExchange.Redis;
using HangfireApi.Filter;

namespace HangfireApi
{
    public class Startup
    {
        public Startup(IHostingEnvironment env)
        {
            Configuration = new ConfigurationBuilder()
                            .SetBasePath(env.ContentRootPath)
                            .AddJsonFile("appsettings.json", optional: true, reloadOnChange: true)
                            .AddJsonFile($"appsettings.{env.EnvironmentName}.json", optional: true, reloadOnChange: true)
                            .AddEnvironmentVariables()
                            .Build();
        }

        public IConfiguration Configuration { get; }

        // This method gets called by the runtime. Use this method to add services to the container.
        public void ConfigureServices(IServiceCollection services)
        {


            #region Cors 配置
            //生产环境 的cors
            services.AddCors(options =>
            {
                options.AddPolicy("CorsProd",
                builder => builder.AllowAnyOrigin()
                //builder => builder.WithOrigins(Configuration["Cors"].Split(','))
                .AllowAnyMethod()
                .AllowAnyHeader()
                .AllowCredentials().SetPreflightMaxAge(TimeSpan.FromMinutes(30)));
            });
            //开发环境的cors
            services.AddCors(options =>
            {
                options.AddPolicy("CorsDev",
                builder => builder.AllowAnyOrigin()
                .AllowAnyMethod()
                .AllowAnyHeader()
                .AllowCredentials().SetPreflightMaxAge(TimeSpan.FromMinutes(30)));
            });
            #endregion

            #region 授权配置
            //读取jwt配置文件
            var signingKey = new SymmetricSecurityKey(Encoding.UTF8.GetBytes(Configuration["Jwt:SecretKey"].ToString()));
            var tokenValidationParameters = new TokenValidationParameters
            {
                ValidateIssuerSigningKey = true,
                IssuerSigningKey = signingKey,
                ValidateIssuer = true,
                ValidIssuer = Configuration["Jwt:Issuer"].ToString(),//发行人
                ValidateAudience = true,
                ValidAudience = Configuration["Jwt:Audience"].ToString(),//订阅人
                ValidateLifetime = true,
                ClockSkew = TimeSpan.Zero,
                RequireExpirationTime = true,
            };

            services.AddAuthentication(options =>
            {
                options.DefaultAuthenticateScheme = JwtBearerDefaults.AuthenticationScheme;
                options.DefaultChallengeScheme = JwtBearerDefaults.AuthenticationScheme;
            })
            .AddJwtBearer(o =>
            {
                o.RequireHttpsMetadata = false;
                o.TokenValidationParameters = tokenValidationParameters;
                o.Events = new JwtBearerEvents
                {
                    OnTokenValidated = context =>
                    {
                        if (context.Request.Path.Value.ToString() == "/api/logout")
                        {
                            var token = ((context as TokenValidatedContext).SecurityToken as JwtSecurityToken).RawData;
                        }
                        return Task.CompletedTask;
                    }
                };
            });
            #endregion

            #region redis配置
            services.AddDistributedRedisCache(options =>
            {
                options.InstanceName = Configuration["Redis:InstanceName"].ToString();
                options.Configuration = $"{Configuration["Redis:HostName"].ToString()}:{Configuration["Redis:Port"].ToString()},allowAdmin=true,password={Configuration["Redis:Password"].ToString()},defaultdatabase={Configuration["Redis:Defaultdatabase"].ToString()}";
            });

            // 添加 Hangfire 组件，并且指定使用 Redis 进行持久化存储
            services.AddHangfire(x =>
            {
                //获取 Redis 连接字符串
                x.UseRedisStorage(ConnectionMultiplexer.Connect(Configuration["hangfireRedis"]));

            });
            #endregion





            services.AddSingleton<IConfiguration>(Configuration);

            //注入授权Handler
            services.AddSingleton<IAuthorizationHandler, PermissionAuthorizationHandler>();
            services.AddSingleton<IPermissionService, PermissionService>();
            services.AddSingleton<IEquipmentService, EquipmentService>();
            services.AddSingleton<IDistributionPlanService, DistributionPlanService>();

            #region 版本控制
            services.AddApiVersioning(Options =>
            {
                Options.ReportApiVersions = true;//可选，为true API返回响应标头中支持的版本信息
                Options.ApiVersionReader = new QueryStringApiVersionReader(parameterName: "api-version");
                Options.AssumeDefaultVersionWhenUnspecified = true;
                Options.DefaultApiVersion = new Microsoft.AspNetCore.Mvc.ApiVersion(6, 0);
            });
            #endregion

            #region AutoMapper
            services.AddAutoMapper();
            #endregion

            services.AddMvc().AddJsonOptions(op => op.SerializerSettings.ContractResolver =
                                        new Newtonsoft.Json.Serialization.DefaultContractResolver());

            #region Mongodb配置
            services.Configure<MongodbOptions>(options =>
            {
                options.ConnectionString = Configuration.GetSection("MongoConnection:ConnectionString").Value;
                options.Database = Configuration.GetSection("MongoConnection:Database").Value;
            });
            #endregion

            #region steeltoe
            services.AddDiscoveryClient(Configuration);
            #endregion
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IHostingEnvironment env, ILoggerFactory loggerFactory)
        {
            if (env.IsProduction())
            {
                app.UseCors("CorsProd");
            }
            else
            {
                app.UseCors("CorsDev");
                app.UseDeveloperExceptionPage();
                app.UseDatabaseErrorPage();
                app.UseBrowserLink();
            }

            app.UseAuthentication();

            app.UseMvc();

            #region steeltoe
            app.UseDiscoveryClient();
            #endregion

            #region HangFire

            //启动hangfire面板
            //app.UseHangfireDashboard();
            //配置hangfire面板访问权限
            var options = new DashboardOptions
            {
                Authorization = new[] { new HangfireAuthorizationFilter() }
            };
            app.UseHangfireDashboard("/hangfire", options);

            //hangfire 配置项
            var jobOptions = new BackgroundJobServerOptions
            {
                Queues = new[] { "test", "default" },//队列名称，只能为小写
                WorkerCount = Environment.ProcessorCount * 5, //并发任务数
                ServerName = "hangfire1",//服务器名称

            };
            //启动Hangfire服务
            app.UseHangfireServer(jobOptions);

            #endregion


            #region Nlog 引入
            loggerFactory.AddNLog();//添加NLog
            env.ConfigureNLog("nlog.config");//读取Nlog配置文件
            app.AddNLogWeb();
            #endregion

            #region 定时评价
            RecurringJob.AddOrUpdate<IEquipmentService>(a => a.TimeOutEvaluateAsync(5, "系统", 5), "0/5 * * * *", TimeZoneInfo.Local);
            RecurringJob.AddOrUpdate<IDistributionPlanService>(a => a.TimeOutEvaluateAsync(5, "系统", 5), "0/1 * * * *", TimeZoneInfo.Local);
            #endregion

        }
    }
}
